#ifndef __argf_h__
#define __argf_h__

#ifndef _ARGF_PRIVATE_H_

  /***
   * The definitions in this section are for the public use of argf.
   * This section is excluded for the argf libraries - the definition
   * of Args() specifies the correct usage but the code is written
   * with varargs and the compiler complains.
   * The #defined constants after this are needed by both the argf
   * libraries and the public use.
   */
  
#include "utils.h"

/* don't really want to have this here (is in arg-desc.h)
   but gcc makes various complaints and warnings if it is not here */
struct ARG_DESC {
  int			magic_number;	/* ARG_MAGIC_START or ARG_MAGIC_END */
  struct ARG_LIST	**arg_list;
  int			n_lists;
  char			*name;
  int			filling_aps;	/* 1 if we are just filling aps, not
					   building the whole thing */
  int			fill_list;	/* next list to fill */
  int			complete;
  char			**option_names;	/* to check for ambiguities */
  int			(*func_ptr)();
};

extern void	Args(struct ARG_DESC *, char *, ...);
extern int	CountArgs(char **);
extern void	EndArgs(struct ARG_DESC *);
extern char **	ParseArgs(struct ARG_DESC *, int, char **, int);
extern struct ARG_DESC *StartArgs(char *);
extern void	ArgsSetRealSize(int);

#endif /* _ARGF_PRVIATE_H_ */

#define EXTRA_OPTIONS		1
#define EXTRA_ARGS		2
#define NO_RETURN_ON_ERROR	4
#define RETURN_ON_ERROR		8
#define RETURN_DUP_ARGS		16

#endif /* __argf_h__ */
