 #include <string.h>
 #include <stdlib.h>
 #ifdef USE_TAP_LIBRARIES
   #define NO_String_TYPE
   #include <tap/tapmath.h>
 #else
   #include "real.h"
   #include "config.h"
 #endif /* USE_TAP_LIBRARIES */
 #include "vcalc.h"
 #include "calcgram.tab.h"
 void skipComment(void);
 void badInput(void);
 int yywrap(void);
 int isatty(int);
 extern int eof_flag;
D       [0-9]
A	[_a-zA-Z]
C	[_a-zA-Z0-9.]
%%
"\""(([^"])|(\\\"))*"\""	return (catInput(yytext), yylval.str=massage(yytext), STRING);
{A}{C}*				return (catInput(yytext), yylval.str=strdup(yytext), IDENT);
"-"?{D}+			return (catInput(yytext), yylval.val=atoi(yytext), INUM);
"-"?{D}+("."{D}*)?([Ee]"-"?{D}+)?	return (catInput(yytext), yylval.val=atof(yytext), RNUM);
"-"?"."{D}+([Ee]"-"?{D}+)?	return (catInput(yytext), yylval.val=atof(yytext),  RNUM);
"|"				return catInput(yytext), BAR;
"("				return catInput(yytext), LPAREN;
")"				return catInput(yytext), RPAREN;
"<="				return catInput(yytext), LESSEQUAL;
">="				return catInput(yytext), GRTREQUAL;
"<"				return catInput(yytext), LANGLE;
">"				return catInput(yytext), RANGLE;
"?<"				return catInput(yytext), LESS;
"?>"				return catInput(yytext), GRTR;
"["				return catInput(yytext), LSQUARE;
"]"				return catInput(yytext), RSQUARE;
"{"				return catInput(yytext), LCURLY;
"}"				return catInput(yytext), RCURLY;
"-"				return catInput(yytext), MINUS;
"+"				return catInput(yytext), PLUS;
"*"				return catInput(yytext), TIMES;
"/"				return catInput(yytext), DIVIDE;
"@*"				return catInput(yytext), CTIMES;
"@/"				return catInput(yytext), CDIVIDE;
"&*"				return catInput(yytext), TTIMES;
"."				return catInput(yytext), DOT;
","				return catInput(yytext), COMMA;
"'"				return catInput(yytext), QUOTE;
"^"				return catInput(yytext), HAT;
"**"				return catInput(yytext), EXP;
"=="				return catInput(yytext), DBLEQUALS;
"?="				return catInput(yytext), DBLEQUALS;
"!="				return catInput(yytext), NOTEQUALS;
"="				return catInput(yytext), EQUALS;
"!"				return catInput(yytext), BANG;
"\n"				return catInput(yytext), NEWLINE;
";"				return catInput(yytext), SEMICOLON;
":"				return catInput(yytext), COLON;
[ \t]+				catInput(yytext);
"\\\n"				catInput(yytext);
"#"     			catInput(yytext), skipComment();
.				badInput();
%%
void skipComment()
{
  char c;
  while ((c=input()) != '\n')
    *(inputLineEnd++) = c;
  *inputLineEnd = '\0';
  unput('\n');
  return;
}

void badInput()
{
  int i=0;
  while ((yytext[++i]=input())!='\n') ;
  yytext[i] = '\0';
  AbortExpr("lex: bad input \"%s\"\n", yytext);
}

int yywrap()
{
  extern FILE **files;
  extern int nfile;
  if (files==NULL || files[++nfile]==NULL) {
    eof_flag = 1;
    return(1);
  } else {
    yyin = files[nfile];
    return 0;
  }
}
