#ifndef __utils_h__
#define __utils_h__

#include <stdio.h>
#include <stdarg.h>

#define MAX_RAND_INT 0x7FFFFFFF

typedef char *string;

extern FILE *dout;
extern FILE *din;
extern char *myname;
extern char *true_string;
extern char *false_string;
extern char *undefined_string;
extern char *bad_boolean_string;
extern char *BooleanString(int);
extern int stand_alone;	/* 1 if this is in a program, 0 if in a command */
extern int IsAsciiString(char *);

extern void	Error(char *, ...);
extern void	ErrorAbort(char *, ...);

extern void	Abort(void);
extern void	ErrorV(char *, va_list *);
extern char	*SysError(int);
extern int	IsLegalVarName(char *);

extern void *	reallocOrAbort(void *, unsigned int);
extern void *	callocOrAbort(unsigned int, unsigned int);

#ifndef ALLOC_MACROS
#define ALLOC_MACROS

#define Malloc(TYPE, SIZE) \
  ((TYPE*)malloc((unsigned) (SIZE)))

#define Realloc(TYPE, OLD, NUMBER) \
  ((TYPE*)realloc((char*)(OLD), sizeof(TYPE)*(unsigned) (NUMBER)))
#define ReallocOrAbort(TYPE, OLD, NUMBER) \
  ((TYPE*)reallocOrAbort((char*)(OLD), sizeof(TYPE)*(unsigned) (NUMBER)))
#define ITempRealloc(TYPE, OLD, N) \
  ((TYPE*)reallocOrAbort((char*)(OLD), (unsigned) (N) * (unsigned)sizeof(TYPE)))

#define Calloc(TYPE, N) \
  ((TYPE*)calloc((unsigned) (N), (unsigned)sizeof(TYPE)))
#define CallocOrAbort(TYPE, N) \
  ((TYPE*)callocOrAbort((unsigned) (N), (unsigned)sizeof(TYPE)))
#define ITempCalloc(TYPE, N) \
  ((TYPE*)callocOrAbort((unsigned) (N), (unsigned)sizeof(TYPE)))

#endif /* ALLOC_MACROS */

#endif /* __utils_h__ */
