enum VarSpace {EXSV_00, SCALAR, VECTOR};
enum VarDirection {EXDIR_00, IMMED, INDIR};

enum NodeType {
  ENUM_NodeType_00,
  Literal,
  Variable,
  Function,
  List,
  Label,
  Operator,
  Sequence
};

struct ExprNode {
  enum NodeType		type;
  int			operator;
  char			*name;
  struct ExprNode	*arg1;
  struct ExprNode	*arg2;
  int			evaluated;
  struct VarNode	*var;
  struct VarNode	*var_image; /* for when a var can be created */
};

enum VarType {
  ENUM_VarType_00,
  Vector,
  Scalar,
  String,
  LNode,
  BitVector
};

typedef unsigned short bitWord;

struct VarNode {
  union {
    struct {
      real			*ptr;
      bitWord			*bw;
      int			dim;
      int			tensor;		/* # of dimensions */
      int			*structure;	/* size of each dim. */
    }			vec;
    struct {
      struct VarNode		*car;
      struct VarNode		*cdr;
    }			l;
    char		*str;
    real		value;
  }		d;
  enum VarType	type;
  short		permanent;
  short		constant;
  char		*name;
};

#define COS	1
#define SIN	2

extern struct ExprNode *newNode(enum NodeType, int,
			        struct ExprNode*, struct ExprNode*);
extern struct ExprNode *ParseExpr(void);
extern void AbortExpr(char *, ...);
extern char *inputLine;
extern char *inputLineEnd;
extern void catInput(char *);
extern char *massage(char *);
